# Generated by Django 4.2.6 on 2024-06-08 00:00

import django.db.models.deletion
import trackingserver_base.models
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("trackingserver_auth", "0001_initial"),
        ("trackingserver_template", "0001_initial"),
    ]

    operations = [
        migrations.CreateModel(
            name="DAGRun",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("run_start_time", models.DateTimeField(null=True)),
                ("run_end_time", models.DateTimeField(null=True)),
                (
                    "run_status",
                    models.CharField(
                        choices=[
                            ("RUNNING", "RUNNING"),
                            ("SUCCESS", "SUCCESS"),
                            ("FAILURE", "FAILURE"),
                            ("UNINITIALIZED", "UNINITIALIZED"),
                        ],
                        max_length=255,
                    ),
                ),
                ("tags", models.JSONField()),
                ("inputs", models.JSONField()),
                ("outputs", trackingserver_base.models.ArrayField(models.CharField())),
                (
                    "dag_template",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="trackingserver_template.dagtemplate",
                    ),
                ),
                (
                    "launched_by",
                    models.ForeignKey(
                        default=None,
                        null=True,
                        on_delete=django.db.models.deletion.PROTECT,
                        to="trackingserver_auth.user",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="NodeRunAttribute",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("name", models.CharField(max_length=63)),
                ("type", models.CharField(max_length=63)),
                ("schema_version", models.IntegerField()),
                ("value", models.JSONField()),
                ("node_name", models.CharField(db_index=True, max_length=255)),
                (
                    "attribute_role",
                    models.CharField(
                        choices=[
                            ("result_summary", "result_summary"),
                            ("error", "error"),
                            ("resource_utilization", "resource_utilization"),
                            ("artifact_link", "artifact_link"),
                            ("logs", "logs"),
                        ],
                        max_length=1024,
                    ),
                ),
                (
                    "dag_run",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="trackingserver_run_tracking.dagrun",
                    ),
                ),
            ],
            options={
                "unique_together": {("name", "node_name", "dag_run")},
            },
        ),
        migrations.CreateModel(
            name="NodeRun",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                ("node_template_name", models.CharField(db_index=True, max_length=255)),
                ("node_name", models.CharField(max_length=1024)),
                (
                    "realized_dependencies",
                    trackingserver_base.models.ArrayField(models.CharField(), null=True),
                ),
                ("start_time", models.DateTimeField(null=True)),
                ("end_time", models.DateTimeField(null=True)),
                (
                    "status",
                    models.CharField(
                        choices=[
                            ("RUNNING", "RUNNING"),
                            ("SUCCESS", "SUCCESS"),
                            ("FAILURE", "FAILURE"),
                            ("UNINITIALIZED", "UNINITIALIZED"),
                        ],
                        max_length=15,
                    ),
                ),
                (
                    "dag_run",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="trackingserver_run_tracking.dagrun",
                    ),
                ),
            ],
            options={
                "unique_together": {("dag_run", "node_name")},
            },
        ),
    ]
